package com.persagy.dmp.org.jms.executor;

import com.persagy.dmp.org.jms.MessageExecutor;
import com.persagy.dmp.org.service.CompanyService;
import com.persagy.dmp.org.service.InitService;
import com.persagy.dmp.rwd.model.DmpMessage;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * @author: yaoll
 * @date: 2020-12-13
 * @verison: 1.0
 */
@Slf4j
@Component
public class GroupCreateExecutor implements MessageExecutor {

	@Autowired
	private InitService initService;

	@Autowired
	private CompanyService companyService;

	@Override
	public void execute(DmpMessage msg) {

		// 初始化分表
		String groupCode = msg.getGroupCode();
		log.info("初始化分表: {}", groupCode);
		initService.initGroup(groupCode);

		// 创建顶级公司
		log.info("创建顶级公司: {}", groupCode);
		companyService.initCompony();

	}
}
