package com.persagy.dmp.rwd.edit.controller;

import com.persagy.dmp.rwd.edit.model.DownloadModel;
import com.persagy.dmp.rwd.edit.service.DownloadService;
import org.apache.poi.ss.usermodel.Workbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.OutputStream;
import java.net.URLEncoder;

@RestController
@RequestMapping("/rwdedit/common")
public class DownloadController {

    @Autowired
    private DownloadService downloadService;

    @GetMapping("/download")
    private void download(@RequestParam String type, HttpServletResponse response) {
        DownloadModel result = downloadService.download(type);
        if ("workbook".equalsIgnoreCase(result.getType())) {
            String fileName = result.getName();
            downloadWorkbook(response, fileName, result.getWorkbook());
        }
    }

    private void downloadWorkbook(HttpServletResponse resp, String fileName, Workbook workbook) {
        OutputStream out = null;
        try {
            resp.reset();// 清空输出流
            String resultFileName = URLEncoder.encode(fileName, "UTF-8");
            resp.setCharacterEncoding("UTF-8");
            resp.setHeader("Content-disposition", "attachment; filename=" + resultFileName);// 设定输出文件头
            resp.setContentType("application/msexcel");// 定义输出类型
            out = resp.getOutputStream();
            workbook.write(out);
            out.flush();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                if (out != null) {
                    out.close();
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}
